diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/qos-txop.cc ns-3.32/src/wifi/model/qos-txop.cc
--- ns-3.31/src/wifi/model/qos-txop.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/qos-txop.cc	2020-10-06 15:35:43.000000000 -0700
@@ -258,7 +258,7 @@
   // lambda to peek the next frame
   auto peek = [this, &tid, &recipient, &it] (Ptr<WifiMacQueue> queue)
     {
-      if (tid == 8 && recipient.IsBroadcast ())  // undefined TID and recipient
+      if (tid == 8 && recipient.IsGroup ())  // undefined TID and recipient
         {
           return queue->PeekFirstAvailable (m_qosBlockedDestinations, it);
         }
@@ -337,9 +337,9 @@
   // the packet can only have been peeked from the block ack manager retransmit
   // queue if:
   // - the peeked packet is a QoS Data frame AND
-  // - the peeked packet is not a broadcast frame AND
+  // - the peeked packet is not a group addressed frame AND
   // - an agreement has been established
-  if (peekedItem->GetHeader ().IsQosData () && !recipient.IsBroadcast ()
+  if (peekedItem->GetHeader ().IsQosData () && !recipient.IsGroup ()
       && GetBaAgreementEstablished (recipient, peekedItem->GetHeader ().GetQosTid ()))
     {
       uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
@@ -380,7 +380,7 @@
         }
 
       // try A-MSDU aggregation
-      if (m_low->GetMsduAggregator () != 0 && !recipient.IsBroadcast () && aggregate)
+      if (m_low->GetMsduAggregator () != 0 && !recipient.IsGroup () && aggregate)
         {
           item = m_low->GetMsduAggregator ()->GetNextAmsdu (recipient, tid, txVector, ampduSize, ppduDurationLimit);
         }
@@ -425,8 +425,8 @@
 
   params.DisableNextData ();
 
-  // broadcast frames
-  if (recipient.IsBroadcast ())
+  // group addressed frames
+  if (recipient.IsGroup ())
     {
       params.DisableRts ();
       params.DisableAck ();
@@ -539,7 +539,7 @@
           // check if a block ack agreement needs to be established
           m_currentHdr = peekedItem->GetHeader ();
           m_currentPacket = peekedItem->GetPacket ();
-          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ()
+          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsGroup ()
               && m_stationManager->GetQosSupported (m_currentHdr.GetAddr1 ())
               && (!m_baManager->ExistsAgreement (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ())
                   || m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (), OriginatorBlockAckAgreement::RESET))
@@ -550,12 +550,12 @@
 
           m_stationManager->UpdateFragmentationThreshold ();
           Ptr<WifiMacQueueItem> item;
-          // non-broadcast QoS Data frames may be sent in MU PPDUs. Given that at this stage
+          // non-group addressed QoS Data frames may be sent in MU PPDUs. Given that at this stage
           // we do not know the bandwidth it would be given nor the selected acknowledgment
           // sequence, we cannot determine the constraints on size and duration limit. Hence,
-          // we only peek the non-broadcast QoS Data frame. MacLow will be in charge of
+          // we only peek the non-group addressed QoS Data frame. MacLow will be in charge of
           // computing the correct limits and dequeue the frame.
-          if (peekedItem->GetHeader ().IsQosData () && !peekedItem->GetHeader ().GetAddr1 ().IsBroadcast ()
+          if (peekedItem->GetHeader ().IsQosData () && !peekedItem->GetHeader ().GetAddr1 ().IsGroup ()
               && !NeedFragmentation ())
             {
               item = Copy (peekedItem);
@@ -1095,7 +1095,7 @@
           // check if a block ack agreement needs to be established
           m_currentHdr = nextFrame->GetHeader ();
           m_currentPacket = nextFrame->GetPacket ();
-          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsBroadcast ()
+          if (m_currentHdr.IsQosData () && !m_currentHdr.GetAddr1 ().IsGroup ()
               && m_stationManager->GetQosSupported (m_currentHdr.GetAddr1 ())
               && (!m_baManager->ExistsAgreement (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid ())
                   || m_baManager->ExistsAgreementInState (m_currentHdr.GetAddr1 (), m_currentHdr.GetQosTid (), OriginatorBlockAckAgreement::RESET))
@@ -1109,12 +1109,12 @@
             {
               item = Copy (m_baManager->GetBar ());
             }
-          // non-broadcast QoS Data frames may be sent in MU PPDUs. Given that at this stage
+          // non-group addressed QoS Data frames may be sent in MU PPDUs. Given that at this stage
           // we do not know the bandwidth it would be given nor the selected acknowledgment
           // sequence, we cannot determine the constraints on size and duration limit. Hence,
-          // we only peek the non-broadcast QoS Data frame. MacLow will be in charge of
+          // we only peek the non-group addressed QoS Data frame. MacLow will be in charge of
           // computing the correct limits and dequeue the frame.
-          else if (nextFrame->GetHeader ().IsQosData () && !nextFrame->GetHeader ().GetAddr1 ().IsBroadcast ())
+          else if (nextFrame->GetHeader ().IsQosData () && !nextFrame->GetHeader ().GetAddr1 ().IsGroup ())
             {
               item = Copy (nextFrame);
             }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/regular-wifi-mac.cc ns-3.32/src/wifi/model/regular-wifi-mac.cc
--- ns-3.31/src/wifi/model/regular-wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/regular-wifi-mac.cc	2020-10-06 15:35:43.000000000 -0700
@@ -28,7 +28,6 @@
 #include "mac-low.h"
 #include "msdu-aggregator.h"
 #include "mpdu-aggregator.h"
-#include "wifi-utils.h"
 #include "mgt-headers.h"
 #include "amsdu-subframe-header.h"
 #include "wifi-net-device.h"
@@ -314,15 +313,15 @@
       Ptr<HeConfiguration> heConfiguration = GetHeConfiguration ();
       capabilities.SetHeSupported (1);
       uint8_t channelWidthSet = 0;
-      if (m_phy->GetChannelWidth () >= 40 && Is2_4Ghz (m_phy->GetFrequency ()))
+      if ((m_phy->GetChannelWidth () >= 40) && (m_phy->GetPhyBand () == WIFI_PHY_BAND_2_4GHZ))
         {
           channelWidthSet |= 0x01;
         }
-      if (m_phy->GetChannelWidth () >= 80 && Is5Ghz (m_phy->GetFrequency ()))
+      if ((m_phy->GetChannelWidth () >= 80) && ((m_phy->GetPhyBand () == WIFI_PHY_BAND_5GHZ) || (m_phy->GetPhyBand () == WIFI_PHY_BAND_6GHZ)))
         {
           channelWidthSet |= 0x02;
         }
-      if (m_phy->GetChannelWidth () >= 160 && Is5Ghz (m_phy->GetFrequency ()))
+      if ((m_phy->GetChannelWidth () >= 160) && ((m_phy->GetPhyBand () == WIFI_PHY_BAND_5GHZ) || (m_phy->GetPhyBand () == WIFI_PHY_BAND_6GHZ)))
         {
           channelWidthSet |= 0x04;
         }
@@ -538,24 +537,6 @@
   return m_qosSupported;
 }
 
-void
-RegularWifiMac::SetVhtSupported (bool enable)
-{
-  //To be removed once deprecated API is cleaned up
-}
-
-void
-RegularWifiMac::SetHtSupported (bool enable)
-{
-  //To be removed once deprecated API is cleaned up
-}
-
-void
-RegularWifiMac::SetHeSupported (bool enable)
-{
-  //To be removed once deprecated API is cleaned up
-}
-
 bool
 RegularWifiMac::GetHtSupported () const
 {
@@ -624,112 +605,6 @@
 }
 
 void
-RegularWifiMac::SetSlot (Time slotTime)
-{
-  NS_LOG_FUNCTION (this << slotTime);
-  m_channelAccessManager->SetSlot (slotTime);
-  m_low->SetSlotTime (slotTime);
-}
-
-Time
-RegularWifiMac::GetSlot (void) const
-{
-  return m_low->GetSlotTime ();
-}
-
-void
-RegularWifiMac::SetSifs (Time sifs)
-{
-  NS_LOG_FUNCTION (this << sifs);
-  m_channelAccessManager->SetSifs (sifs);
-  m_low->SetSifs (sifs);
-}
-
-Time
-RegularWifiMac::GetSifs (void) const
-{
-  return m_low->GetSifs ();
-}
-
-void
-RegularWifiMac::SetEifsNoDifs (Time eifsNoDifs)
-{
-  NS_LOG_FUNCTION (this << eifsNoDifs);
-  m_channelAccessManager->SetEifsNoDifs (eifsNoDifs);
-}
-
-Time
-RegularWifiMac::GetEifsNoDifs (void) const
-{
-  return m_channelAccessManager->GetEifsNoDifs ();
-}
-
-void
-RegularWifiMac::SetRifs (Time rifs)
-{
-  NS_LOG_FUNCTION (this << rifs);
-  m_low->SetRifs (rifs);
-}
-
-Time
-RegularWifiMac::GetRifs (void) const
-{
-  return m_low->GetRifs ();
-}
-
-void
-RegularWifiMac::SetPifs (Time pifs)
-{
-  NS_LOG_FUNCTION (this << pifs);
-  m_low->SetPifs (pifs);
-}
-
-Time
-RegularWifiMac::GetPifs (void) const
-{
-  return m_low->GetPifs ();
-}
-
-void
-RegularWifiMac::SetAckTimeout (Time ackTimeout)
-{
-  NS_LOG_FUNCTION (this << ackTimeout);
-  m_low->SetAckTimeout (ackTimeout);
-}
-
-Time
-RegularWifiMac::GetAckTimeout (void) const
-{
-  return m_low->GetAckTimeout ();
-}
-
-void
-RegularWifiMac::SetBasicBlockAckTimeout (Time blockAckTimeout)
-{
-  NS_LOG_FUNCTION (this << blockAckTimeout);
-  m_low->SetBasicBlockAckTimeout (blockAckTimeout);
-}
-
-Time
-RegularWifiMac::GetBasicBlockAckTimeout (void) const
-{
-  return m_low->GetBasicBlockAckTimeout ();
-}
-
-void
-RegularWifiMac::SetCompressedBlockAckTimeout (Time blockAckTimeout)
-{
-  NS_LOG_FUNCTION (this << blockAckTimeout);
-  m_low->SetCompressedBlockAckTimeout (blockAckTimeout);
-}
-
-Time
-RegularWifiMac::GetCompressedBlockAckTimeout (void) const
-{
-  return m_low->GetCompressedBlockAckTimeout ();
-}
-
-void
 RegularWifiMac::SetAddress (Mac48Address address)
 {
   NS_LOG_FUNCTION (this << address);
@@ -788,37 +663,6 @@
 }
 
 void
-RegularWifiMac::SetRifsSupported (bool enable)
-{
-  NS_LOG_FUNCTION (this << enable);
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      if (htConfiguration)
-        {
-          htConfiguration->SetRifsSupported (enable);
-        }
-    }
-  m_rifsSupported = enable;
-}
-
-bool
-RegularWifiMac::GetRifsSupported (void) const
-{
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      if (htConfiguration)
-        {
-          return htConfiguration->GetRifsSupported ();
-        }
-    }
-  return m_rifsSupported;
-}
-
-void
 RegularWifiMac::Enqueue (Ptr<Packet> packet,
                          Mac48Address to, Mac48Address from)
 {
@@ -1027,27 +871,6 @@
                    MakeBooleanAccessor (&RegularWifiMac::SetQosSupported,
                                         &RegularWifiMac::GetQosSupported),
                    MakeBooleanChecker ())
-    .AddAttribute ("HtSupported",
-                   "This Boolean attribute is set to enable 802.11n support at this STA.",
-                   BooleanValue (false),
-                   MakeBooleanAccessor (&RegularWifiMac::SetHtSupported,
-                                        &RegularWifiMac::GetHtSupported),
-                   MakeBooleanChecker (),
-                   TypeId::DEPRECATED, "Not used anymore")
-    .AddAttribute ("VhtSupported",
-                   "This Boolean attribute is set to enable 802.11ac support at this STA.",
-                   BooleanValue (false),
-                   MakeBooleanAccessor (&RegularWifiMac::SetVhtSupported,
-                                        &RegularWifiMac::GetVhtSupported),
-                   MakeBooleanChecker (),
-                   TypeId::DEPRECATED, "Not used anymore")
-    .AddAttribute ("HeSupported",
-                   "This Boolean attribute is set to enable 802.11ax support at this STA.",
-                   BooleanValue (false),
-                   MakeBooleanAccessor (&RegularWifiMac::SetHeSupported,
-                                        &RegularWifiMac::GetHeSupported),
-                   MakeBooleanChecker (),
-                   TypeId::DEPRECATED, "Not used anymore")
     .AddAttribute ("CtsToSelfSupported",
                    "Use CTS to Self when using a rate that is not in the basic rate set.",
                    BooleanValue (false),
@@ -1175,13 +998,6 @@
                    MakeBooleanAccessor (&RegularWifiMac::SetShortSlotTimeSupported,
                                         &RegularWifiMac::GetShortSlotTimeSupported),
                    MakeBooleanChecker ())
-    .AddAttribute ("RifsSupported",
-                   "Whether or not RIFS is supported (only used by HT APs or STAs).",
-                   BooleanValue (false),
-                   MakeBooleanAccessor (&RegularWifiMac::SetRifsSupported,
-                                        &RegularWifiMac::GetRifsSupported),
-                   MakeBooleanChecker (),
-                   TypeId::DEPRECATED, "Use the HtConfiguration instead")
     .AddAttribute ("Txop",
                    "The Txop object.",
                    PointerValue (),
@@ -1220,47 +1036,39 @@
 }
 
 void
-RegularWifiMac::FinishConfigureStandard (WifiPhyStandard standard)
+RegularWifiMac::ConfigureStandard (WifiStandard standard)
 {
   NS_LOG_FUNCTION (this << standard);
   uint32_t cwmin = 0;
   uint32_t cwmax = 0;
   switch (standard)
     {
-    case WIFI_PHY_STANDARD_80211ax_5GHZ:
-    case WIFI_PHY_STANDARD_80211ac:
-    case WIFI_PHY_STANDARD_80211n_5GHZ:
+    case WIFI_STANDARD_80211n_5GHZ:
+    case WIFI_STANDARD_80211ac:
+    case WIFI_STANDARD_80211ax_5GHZ:
+    case WIFI_STANDARD_80211ax_6GHZ:
       {
         EnableAggregation ();
-        //To be removed once deprecated attributes are removed
-        Ptr<HtConfiguration> htConfiguration = GetHtConfiguration ();
-        NS_ASSERT (htConfiguration);
-        htConfiguration->SetRifsSupported (m_rifsSupported);
         SetQosSupported (true);
         cwmin = 15;
         cwmax = 1023;
         break;
       }
-    case WIFI_PHY_STANDARD_80211ax_2_4GHZ:
-    case WIFI_PHY_STANDARD_80211n_2_4GHZ:
+    case WIFI_STANDARD_80211ax_2_4GHZ:
+    case WIFI_STANDARD_80211n_2_4GHZ:
       {
         EnableAggregation ();
-        //To be removed once deprecated RifsSupported attribute is removed
-        Ptr<HtConfiguration> htConfiguration = GetHtConfiguration ();
-        NS_ASSERT (htConfiguration);
-        htConfiguration->SetRifsSupported (m_rifsSupported);
         SetQosSupported (true);
       }
-    case WIFI_PHY_STANDARD_80211g:
+    case WIFI_STANDARD_80211g:
       SetErpSupported (true);
-    case WIFI_PHY_STANDARD_holland:
-    case WIFI_PHY_STANDARD_80211a:
-    case WIFI_PHY_STANDARD_80211_10MHZ:
-    case WIFI_PHY_STANDARD_80211_5MHZ:
+    case WIFI_STANDARD_holland:
+    case WIFI_STANDARD_80211a:
+    case WIFI_STANDARD_80211p:
       cwmin = 15;
       cwmax = 1023;
       break;
-    case WIFI_PHY_STANDARD_80211b:
+    case WIFI_STANDARD_80211b:
       SetDsssSupported (true);
       cwmin = 31;
       cwmax = 1023;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/regular-wifi-mac.h ns-3.32/src/wifi/model/regular-wifi-mac.h
--- ns-3.31/src/wifi/model/regular-wifi-mac.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/regular-wifi-mac.h	2020-10-06 15:35:43.000000000 -0700
@@ -54,22 +54,10 @@
   virtual ~RegularWifiMac ();
 
   // Implementations of pure virtual methods.
-  void SetSlot (Time slotTime);
-  void SetSifs (Time sifs);
-  void SetEifsNoDifs (Time eifsNoDifs);
-  void SetPifs (Time pifs);
-  void SetRifs (Time rifs);
-  void SetAckTimeout (Time ackTimeout);
   void SetShortSlotTimeSupported (bool enable);
   void SetSsid (Ssid ssid);
   void SetAddress (Mac48Address address);
   void SetPromisc (void);
-  Time GetRifs (void) const;
-  Time GetPifs (void) const;
-  Time GetSifs (void) const;
-  Time GetSlot (void) const;
-  Time GetEifsNoDifs (void) const;
-  Time GetAckTimeout (void) const;
   bool GetShortSlotTimeSupported (void) const;
   Ssid GetSsid (void) const;
   Mac48Address GetAddress (void) const;
@@ -80,6 +68,7 @@
   Ptr<WifiPhy> GetWifiPhy (void) const;
   void ResetWifiPhy (void);
   virtual void SetWifiRemoteStationManager (const Ptr<WifiRemoteStationManager> stationManager);
+  void ConfigureStandard (WifiStandard standard);
 
   /**
    * This type defines the callback of a higher layer that a
@@ -95,14 +84,6 @@
   void SetLinkUpCallback (Callback<void> linkUp);
   void SetLinkDownCallback (Callback<void> linkDown);
 
-  /* Next functions are not pure virtual so non-QoS WifiMacs are not
-   * forced to implement them.
-   */
-  void SetBasicBlockAckTimeout (Time blockAckTimeout);
-  Time GetBasicBlockAckTimeout (void) const;
-  void SetCompressedBlockAckTimeout (Time blockAckTimeout);
-  Time GetCompressedBlockAckTimeout (void) const;
-
   // Should be implemented by child classes
   virtual void Enqueue (Ptr<Packet> packet, Mac48Address to) = 0;
 
@@ -114,22 +95,6 @@
    */
   void SetCtsToSelfSupported (bool enable);
   /**
-   * Enable or disable RIFS feature.
-   *
-   * \param enable true if RIFS is to be supported,
-   *               false otherwise
-   * \deprecated
-   */
-  void SetRifsSupported (bool enable);
-  /**
-   * \return whether the device supports RIFS capability.
-   *
-   * \return true if short RIFS is supported,
-   *         false otherwise.
-   * \deprecated
-   */
-  bool GetRifsSupported (void) const;
-  /**
    * \param bssid the BSSID of the network that this device belongs to.
    */
   void SetBssid (Mac48Address bssid);
@@ -226,20 +191,6 @@
   Ptr<QosTxop> GetBKQueue (void) const;
 
   /**
-   * \param standard the PHY standard to be used
-   *
-   * This method is called by ns3::WifiMac::ConfigureStandard to
-   * complete the configuration process for a requested PHY standard.
-   *
-   * This method may be overridden by a derived class (e.g., in order
-   * to apply DCF or EDCA parameters specific to the usage model it is
-   * dealing with), in which case the reimplementation may choose to
-   * deal with certain values in the WifiPhyStandard enumeration, and
-   * chain up to this implementation to deal with the remainder.
-   */
-  void FinishConfigureStandard (WifiPhyStandard standard);
-
-  /**
    * \param cwMin the minimum contention window size
    * \param cwMax the maximum contention window size
    *
@@ -328,12 +279,6 @@
   bool GetQosSupported () const;
 
   /**
-   * Enable or disable HT support for the device.
-   *
-   * \param enable whether HT is supported
-   */
-  void SetHtSupported (bool enable);
-  /**
    * Return whether the device supports HT.
    *
    * \return true if HT is supported, false otherwise
@@ -341,12 +286,6 @@
   bool GetHtSupported () const;
 
   /**
-   * Enable or disable VHT support for the device.
-   *
-   * \param enable whether VHT is supported
-   */
-  void SetVhtSupported (bool enable);
-  /**
    * Return whether the device supports VHT.
    *
    * \return true if VHT is supported, false otherwise
@@ -380,12 +319,6 @@
   bool GetDsssSupported () const;
 
   /**
-   * Enable or disable HE support for the device.
-   *
-   * \param enable whether HE is supported
-   */
-  void SetHeSupported (bool enable);
-  /**
    * Return whether the device supports HE.
    *
    * \return true if HE is supported, false otherwise
@@ -505,7 +438,6 @@
   TracedCallback<const WifiMacHeader &> m_txErrCallback; ///< transmit error callback
 
   bool m_shortSlotTimeSupported; ///< flag whether short slot time is supported
-  bool m_rifsSupported; ///< flag whether RIFS is supported (deprecated)
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/rraa-wifi-manager.cc ns-3.32/src/wifi/model/rraa-wifi-manager.cc
--- ns-3.31/src/wifi/model/rraa-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/rraa-wifi-manager.cc	2020-10-06 15:35:43.000000000 -0700
@@ -121,6 +121,8 @@
 RraaWifiManager::SetupPhy (const Ptr<WifiPhy> phy)
 {
   NS_LOG_FUNCTION (this << phy);
+  m_sifs = phy->GetSifs ();
+  m_difs = m_sifs + 2 * phy->GetSlot ();
   uint8_t nModes = phy->GetNModes ();
   for (uint8_t i = 0; i < nModes; i++)
     {
@@ -129,8 +131,8 @@
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
       /* Calculate the TX Time of the Data and the corresponding Ack */
-      Time dataTxTime = phy->CalculateTxDuration (m_frameLength, txVector, phy->GetFrequency ());
-      Time ackTxTime = phy->CalculateTxDuration (m_ackLength, txVector, phy->GetFrequency ());
+      Time dataTxTime = phy->CalculateTxDuration (m_frameLength, txVector, phy->GetPhyBand ());
+      Time ackTxTime = phy->CalculateTxDuration (m_ackLength, txVector, phy->GetPhyBand ());
       NS_LOG_DEBUG ("Calculating TX times: Mode= " << mode << " DataTxTime= " << dataTxTime << " AckTxTime= " << ackTxTime);
       AddCalcTxTime (mode, dataTxTime + ackTxTime);
     }
@@ -141,8 +143,6 @@
 RraaWifiManager::SetupMac (const Ptr<WifiMac> mac)
 {
   NS_LOG_FUNCTION (this);
-  m_sifs = mac->GetSifs ();
-  m_difs = m_sifs + 2 * mac->GetSlot ();
   WifiRemoteStationManager::SetupMac (mac);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/rrpaa-wifi-manager.cc ns-3.32/src/wifi/model/rrpaa-wifi-manager.cc
--- ns-3.31/src/wifi/model/rrpaa-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/rrpaa-wifi-manager.cc	2020-10-06 15:35:43.000000000 -0700
@@ -148,6 +148,8 @@
 RrpaaWifiManager::SetupPhy (const Ptr<WifiPhy> phy)
 {
   NS_LOG_FUNCTION (this << phy);
+  m_sifs = phy->GetSifs ();
+  m_difs = m_sifs + 2 * phy->GetSlot ();
   m_nPowerLevels = phy->GetNTxPower ();
   m_maxPowerLevel = m_nPowerLevels  - 1;
   m_minPowerLevel = 0;
@@ -159,8 +161,8 @@
       txVector.SetMode (mode);
       txVector.SetPreambleType (WIFI_PREAMBLE_LONG);
       /* Calculate the TX Time of the Data and the corresponding Ack */
-      Time dataTxTime = phy->CalculateTxDuration (m_frameLength, txVector, phy->GetFrequency ());
-      Time ackTxTime = phy->CalculateTxDuration (m_ackLength, txVector, phy->GetFrequency ());
+      Time dataTxTime = phy->CalculateTxDuration (m_frameLength, txVector, phy->GetPhyBand ());
+      Time ackTxTime = phy->CalculateTxDuration (m_ackLength, txVector, phy->GetPhyBand ());
       NS_LOG_DEBUG ("Calculating TX times: Mode= " << mode << " DataTxTime= " << dataTxTime << " AckTxTime= " << ackTxTime);
       AddCalcTxTime (mode, dataTxTime + ackTxTime);
     }
@@ -171,8 +173,6 @@
 RrpaaWifiManager::SetupMac (const Ptr<WifiMac> mac)
 {
   NS_LOG_FUNCTION (this << mac);
-  m_sifs = mac->GetSifs ();
-  m_difs = m_sifs + 2 * mac->GetSlot ();
   WifiRemoteStationManager::SetupMac (mac);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/spectrum-wifi-phy.cc ns-3.32/src/wifi/model/spectrum-wifi-phy.cc
--- ns-3.31/src/wifi/model/spectrum-wifi-phy.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/spectrum-wifi-phy.cc	2020-10-06 15:35:43.000000000 -0700
@@ -179,10 +179,10 @@
 }
 
 void
-SpectrumWifiPhy::ConfigureStandard (WifiPhyStandard standard)
+SpectrumWifiPhy::ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band)
 {
-  NS_LOG_FUNCTION (this << standard);
-  WifiPhy::ConfigureStandard (standard);
+  NS_LOG_FUNCTION (this << standard << band);
+  WifiPhy::ConfigureStandardAndBand (standard, band);
   if (IsInitialized ())
     {
       ResetSpectrumModel ();
@@ -337,33 +337,35 @@
 SpectrumWifiPhy::GetBandBandwidth (void) const
 {
   uint32_t bandBandwidth = 0;
-  switch (GetStandard ())
+  switch (GetPhyStandard ())
     {
     case WIFI_PHY_STANDARD_80211a:
     case WIFI_PHY_STANDARD_80211g:
     case WIFI_PHY_STANDARD_holland:
     case WIFI_PHY_STANDARD_80211b:
-    case WIFI_PHY_STANDARD_80211n_2_4GHZ:
-    case WIFI_PHY_STANDARD_80211n_5GHZ:
+    case WIFI_PHY_STANDARD_80211n:
     case WIFI_PHY_STANDARD_80211ac:
       // Use OFDM subcarrier width of 312.5 KHz as band granularity
       bandBandwidth = 312500;
       break;
-    case WIFI_PHY_STANDARD_80211_10MHZ:
-      // Use OFDM subcarrier width of 156.25 KHz as band granularity
-      bandBandwidth = 156250;
+    case WIFI_PHY_STANDARD_80211p:
+      if (GetChannelWidth () == 5)
+        {
+          // Use OFDM subcarrier width of 78.125 KHz as band granularity
+          bandBandwidth = 78125;
+        }
+      else
+        {
+          // Use OFDM subcarrier width of 156.25 KHz as band granularity
+          bandBandwidth = 156250;
+        }
       break;
-    case WIFI_PHY_STANDARD_80211_5MHZ:
-      // Use OFDM subcarrier width of 78.125 KHz as band granularity
-      bandBandwidth = 78125;
-      break;
-    case WIFI_PHY_STANDARD_80211ax_2_4GHZ:
-    case WIFI_PHY_STANDARD_80211ax_5GHZ:
+    case WIFI_PHY_STANDARD_80211ax:
       // Use OFDM subcarrier width of 78.125 KHz as band granularity
       bandBandwidth = 78125;
       break;
     default:
-      NS_FATAL_ERROR ("Standard unknown: " << GetStandard ());
+      NS_FATAL_ERROR ("Standard unknown: " << GetPhyStandard ());
       break;
     }
   return bandBandwidth;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/spectrum-wifi-phy.h ns-3.32/src/wifi/model/spectrum-wifi-phy.h
--- ns-3.31/src/wifi/model/spectrum-wifi-phy.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/spectrum-wifi-phy.h	2020-10-06 15:35:43.000000000 -0700
@@ -155,7 +155,8 @@
   virtual void SetChannelNumber (uint8_t id);
   virtual void SetFrequency (uint16_t freq);
   virtual void SetChannelWidth (uint16_t channelwidth);
-  virtual void ConfigureStandard (WifiPhyStandard standard);
+  virtual void ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band);
+
 
 protected:
   // Inherited
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/sta-wifi-mac.cc ns-3.32/src/wifi/model/sta-wifi-mac.cc
--- ns-3.31/src/wifi/model/sta-wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/sta-wifi-mac.cc	2020-10-06 15:35:43.000000000 -0700
@@ -776,12 +776,12 @@
       if (capabilities.IsShortSlotTime () == true)
         {
           //enable short slot time
-          SetSlot (MicroSeconds (9));
+          m_phy->SetSlot (MicroSeconds (9));
         }
       else
         {
           //disable short slot time
-          SetSlot (MicroSeconds (20));
+          m_phy->SetSlot (MicroSeconds (20));
         }
     }
   if (GetQosSupported ())
@@ -818,14 +818,6 @@
             {
               m_stationManager->SetUseGreenfieldProtection (false);
             }
-          if (!GetVhtSupported () && GetHtConfiguration ()->GetRifsSupported () && htOperation.GetRifsMode ())
-            {
-              m_stationManager->SetRifsPermitted (true);
-            }
-          else
-            {
-              m_stationManager->SetRifsPermitted (false);
-            }
         }
     }
   if (GetVhtSupported ())
@@ -916,7 +908,7 @@
       if (!isErpAllowed)
         {
           //disable short slot time and set cwMin to 31
-          SetSlot (MicroSeconds (20));
+          m_phy->SetSlot (MicroSeconds (20));
           ConfigureContentionWindow (31, 1023);
         }
       else
@@ -926,12 +918,12 @@
           if (m_stationManager->GetShortSlotTimeEnabled ())
             {
               //enable short slot time
-              SetSlot (MicroSeconds (9));
+              m_phy->SetSlot (MicroSeconds (9));
             }
           else
             {
               //disable short slot time
-              SetSlot (MicroSeconds (20));
+              m_phy->SetSlot (MicroSeconds (20));
             }
           ConfigureContentionWindow (15, 1023);
         }
@@ -963,7 +955,7 @@
       if (!isErpAllowed)
         {
           //disable short slot time and set cwMin to 31
-          SetSlot (MicroSeconds (20));
+          m_phy->SetSlot (MicroSeconds (20));
           ConfigureContentionWindow (31, 1023);
         }
       else
@@ -973,12 +965,12 @@
           if (m_stationManager->GetShortSlotTimeEnabled ())
             {
               //enable short slot time
-              SetSlot (MicroSeconds (9));
+              m_phy->SetSlot (MicroSeconds (9));
             }
           else
             {
               //disable short slot time
-              SetSlot (MicroSeconds (20));
+              m_phy->SetSlot (MicroSeconds (20));
             }
           ConfigureContentionWindow (15, 1023);
         }
@@ -1019,14 +1011,6 @@
             {
               m_stationManager->SetUseGreenfieldProtection (false);
             }
-          if (!GetVhtSupported () && GetHtConfiguration ()->GetRifsSupported () && htOperation.GetRifsMode ())
-            {
-              m_stationManager->SetRifsPermitted (true);
-            }
-          else
-            {
-              m_stationManager->SetRifsPermitted (false);
-            }
         }
     }
   if (GetVhtSupported ())
